<?php
/******************************
Name: dkpMonExport.php
Revision: $Revision$
Author(s): Dahn (dahnwow@mac.com)
Description: Dumps DKP data from eqDKP into a csv based table
Dependencies: eqDKP

	------------------
	dkpMonExport.php
	Version 0.1
	2006.11.08 - initial version, built from GetDKP .php file
	
TODO:
	add instructions to specify multiple pools
	combine various custom files (pool names, item values, dkp values) into this file

 ******************************/

$eqdkp_root_path = '../';
define('EQDKP_INC', true);
include_once($eqdkp_root_path . 'common.php');

$poolTables = array();
// ############# Configuration variables.  Edit as necessary #######################################
$poolcount = 1;
$poolTables[0] = MEMBERS_TABLE;
$poolTables[1] = "";
$poolTables[2] = "";
$poolTables[3] = "";
$poolTables[4] = "";
// Add additional pool array elements as needed

// ############# you dont have to change anything below !!!!  ######################################

$version = "0.1";
$eqdkp_version = "1.3.x";
$date_created = date("D M d H:i:s Y");

function strto_wowutf($str)
{
	$str_encoded = utf8_encode($str);
	return $str_encoded;
}

// ############# ######################################


// Get raidpoints without spitting out the whole page

echo "\n";
echo "--[[\n";
echo "   This file was generated by dkpMonInit.php.\n";
echo "\n"; 
echo "   Each string in the table corresponds to a line in the CSV version of your database.\n";
echo "   The format for each string in the table is:\n";
echo "   \"<name>:<class>:<pool 0 points>:<pool 1 points>:<pool 2 points>:... etc\"\n";
echo "    where <class> must be the English name of the class\n";
echo "      ie: one of 'WARRIOR', 'MAGE', 'HUNTER', 'PRIEST', 'PALADIN', 'SHAMAN', 'ROGUE', 'DRUID', or 'WARLOCK'\n";
echo "   The point value for each pool can be any floating point number so long as it\'s not in exponential format.\n";
echo "]]\n";
echo "\n";
echo "\n";

echo "DKP_pool_count = 2\n";
echo 'DKP_timestamp = "' . $date_created . "\"\n";
echo 'DKP_fileid = ' . time() . "\n";

echo "	\n";
echo "	\n";

echo "-- DKP csv dump generated " . $date_created . "\n";
echo "DKPmonInit.csv = {\n\t";
$member_count = 0;
// Build SQL query based on GET options
$sql = 'SELECT p0.member_id, p0.member_status, p0.member_name, ';
$sqlTableList = "FROM `" . CLASS_TABLE . "` c";
$sqlMatchList = "WHERE c.class_id = p0.member_class_id";

// 'FROM ' . MEMBERS_TABLE . ' m, ' . CLASS_TABLE . ' c, ' . OMC_TABLE . ' o'
$curpool = 0;
while ($curpool < $poolcount)
{
	$poolAlias = "p" . $curpool;
	// calc the current dkp using the typical fields in eqDKP member table
	$sql .= "FORMAT((" . $poolAlias . ".member_earned- " . $poolAlias . ".member_spent+" . $poolAlias . ".member_adjustment), 2) AS " . $poolAlias . "_current, ";

	$sqlTableList .= ", `" . $poolTables[$curpool] . "` " . $poolAlias;
	if ($curpool > 0)
		$sqlMatchList .= " AND p0.member_name = " . $poolAlias . ".member_name";
	$curpool++;
}
$sql .= " c.class_name AS member_class ";
$sql .= $sqlTableList . " ";
$sql .= $sqlMatchList;
if ( !($members_result = $db->query($sql)) )
{
	message_die('Could not obtain member information', '', __FILE__, __LINE__, $sql);
}
while ( $row = $db->fetch_record($members_result) )
{
	if ($member_count != 0)
		echo ",\n\t";

	$member_count++;

	echo '"' . $row['member_name'] . ":" . strtoupper($row['member_class']) . ':';
	$curpool=0;
	while ($curpool < $poolcount)
	{
		echo $row['p' . $curpool . '_current'] . ':';
		$curpool++;
	}
	echo '"';
}
$db->free_result($members_result);

echo "\n};\n";

?>